/*
  O estado do jogo deve ser guardado nesta view
  1 - Verificar se pode entrar na sala , senão redirecionar
  Ter um estado geral do jogo disponivel 


  
*/
<template>
  <div class="content">
    <br>
  


      <h4>Jogar</h4>
      <b-form-group label-cols="4" label-cols-lg="2" label="Partilhar com oponente:" label-for="input-default">
        <b-input-group>
          <b-form-input id="Url" ref="Url"  v-model="url" readonly class="light" v-on:click="handleCopy"></b-form-input>
          <b-input-group-append>
            <b-button variant="secondary" v-on:click="handleCopy">Copiar</b-button>
          </b-input-group-append>
        </b-input-group>
      </b-form-group>
      <br>
      <b-card-group>
        <b-card no-body>
          <template v-slot:header>
            <h6 class="mb-0">O meu jogo <strong v-show="turn == user && status == 'playing'">(a jogar)</strong> </h6>
          </template>
          <div class="d-flex justify-content-center align-items-center h-100">

            <Board :board="playerBoard"
              :playing="turn == user && status == 'playing'"
              :active="turn == user && !hasShips"
              @put-ship="putShip" 
            />

          </div>
        </b-card >
        <b-card header="Adversário" no-body>
          <template v-slot:header>
            <h6 class="mb-0">Adversário 
              <span v-if="creator != user ">{{ creator }}</span>
              <span v-if="creator == user ">{{ opponent }}</span>
              <strong v-show="turn != user && status == 'playing'">(a jogar)</strong>
            </h6>
          </template>
          <div class="d-flex justify-content-center align-items-center h-100">
            <Board 
              :active="turn == user"
              :board="opponentBoard"
              :playing="turn == user && status == 'playing' && canShoot"
              @shot="handleShot"
            opponent/>
          </div>
        </b-card>

        <Chat :roomId="roomId" />
   

      </b-card-group>
      <br>
      <b-card title="Posicionar Navios" v-show="!hasShips">
        <b-card-body>
      
          <b-row class="ship-buttons">
            <b-button variant="danger" v-on:click="reset">Reset</b-button>
            <b-button variant="success" :disabled="!isReady" v-on:click="handleReady">Ready</b-button>
          </b-row><br>
          <b-row class="ship-buttons">
            <b-button variant="primary" v-on:click="toggleDirection">{{ direction }}</b-button> 
            <b-button variant="primary" :disabled="ships.carrier == 0 || selectedShip == 'carrier'" v-on:click="setShip('carrier')">Carrier - {{ ships.carrier }}</b-button> 
            <b-button variant="primary" :disabled="ships.battleship == 0 || selectedShip == 'battleship'" v-on:click="setShip('battleship')">Battleship - {{ ships.battleship }}</b-button> 
            <b-button variant="primary" :disabled="ships.cruiser == 0 || selectedShip == 'cruiser'" v-on:click="setShip('cruiser')">Cruiser - {{ ships.cruiser }}</b-button> 
            <b-button variant="primary" :disabled="ships.submarine == 0 || selectedShip == 'submarine'" v-on:click="setShip('submarine')">Submarine - {{ ships.submarine }}</b-button> 
            <b-button variant="primary" :disabled="ships.destroyer == 0 || selectedShip == 'destroyer'" v-on:click="setShip('destroyer')">Destroyer - {{ ships.destroyer }}</b-button>   
          </b-row>
        </b-card-body>
      </b-card>

       <b-card title="Falta afundar" v-show="status == 'playing'">
        <b-row>
          <b-col>
            <p :class="{'sunk' : carrierSunk}" >Porta-Aviões (5 Quadrados)</p>
            <p :class="{'sunk' : battleshipSunk}" >Couraçado (4 Quadrados)</p>
            <p :class="{'sunk' : cruiserSunk}" >Cruzador (3 Quadrados)</p>
          </b-col>
          <b-col>
            <p :class="{'sunk' : submarineSunk}" >Submarino (3 Quadrados)</p>
            <p :class="{'sunk' : destroyerSunk}" >Contra-torpedeiro (2 Quadrados)</p>
          </b-col>
        </b-row>
       </b-card>

 
    <br>

    <b-modal id="winner-modal" title="O Jogo acabou" ok-only>
      <p v-if="winner == user" class="my-4"><b-icon icon="trophy"/> Você ganhou o jogo.</p>
      <p v-if="winner != user" class="my-4">Você perdeu o jogo.</p>
    </b-modal>

      
  </div>
</template>

<style>
  
  .ship-buttons button {
    margin-right: 10px;

  }

  .sunk {
    text-decoration: line-through;
  }




</style>


<script>

const BOARD_SIZE = 10;

const SHIP_SIZE = {
  "carrier" : 5,
  "battleship" : 4,
  "cruiser" : 3,
  "submarine" : 3,
  "destroyer" : 2,
}

const DEFAULT_SHIPS = {
  carrier: 1,
  battleship: 1,
  cruiser: 1,
  submarine: 1,
  destroyer: 1
}

const DEFAULT_BOARD = [
  [{hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}],
  [{hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}],
  [{hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}],
  [{hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}],
  [{hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}],
  [{hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}],
  [{hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}],
  [{hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}],
  [{hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}],
  [{hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}],
];

const OP_BOARD = [
  [{hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}],
  [{hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}],
  [{hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}],
  [{hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}],
  [{hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}],
  [{hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}],
  [{hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}],
  [{hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}],
  [{hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}],
  [{hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}, {hit: false, me: false}],
];

// @ is an alias to /src
//import HelloWorld from '@/components/HelloWorld.vue'
import UserService from '@/services/User'
import Board from '@/components/Board.vue'
import Chat from '@/components/Chat.vue'

export default {
  name: 'game',
  data() {
    return {
      url : window.location.href,
      lengthTable : 10,
      roomId: this.$route.params.gameId,
      direction: "Horizontal",
      turn: null,
      default_board: DEFAULT_BOARD,
      playerBoard: DEFAULT_BOARD,
      opponentBoard: OP_BOARD,
      ships: DEFAULT_SHIPS,
      shipList: [],
      status: "set",
      user: "",
      creator : "",
      opponent: "",
      selectedShip: "",
      winner: null,
      hasShips: true,
      carrierSunk : false,
      battleshipSunk : false,
      cruiserSunk : false,
      submarineSunk : false,
      destroyerSunk : false,
      canShoot: true,

    }
  },
  sockets : {
    sink : function (ship) {

      this.setSunk(ship);

    },
    winner: function (data) {
      this.winner = data[0];
      this.status = "ended";
      this.$bvModal.show("winner-modal");
      
    },
    ready: function(user) {
      if(this.user == user)
        this.hasShips = true;

    },
    shotResult: function(result) {

      let sound;

      this.canShoot = true;

      if(result.hit) {
        sound =  new Audio('/sounds/hit.wav');
        if(this.user == result.user) {
          this.opponentBoard[result.y][result.x].hit = true;
          this.opponentBoard[result.y][result.x].me = true;
        } else {
          this.playerBoard[result.y][result.x].hit = true;
        }
      } else {
        sound =  new Audio('/sounds/miss.wav');
        if(this.user == result.user) {
          this.opponentBoard[result.y][result.x].hit = true;
        } else {
          this.playerBoard[result.y][result.x].hit = true;
        }
      }

      sound.play();
      this.turn = result.next;
    },

    play : function(turn) {


      this.turn = turn;
      if(this.status != 'playing') {
        this.status = "playing"; 
        let bell = new Audio('/sounds/bell.wav');
        bell.play()
      } 
         
     
    },
    gameError: function() {
     this.$router.push({name : "error"});
    },
    joined : function(game) {
      


      this.creator = game.creator;
      this.opponent = game.opponent;
      this.status = game.status;
      this.hasShips = false;
      this.winner = game.winner;


      if(game.turn) {
        this.turn = game.turn;
      }


      if(game.creator == this.user) {
          if(game.creatorShips.length){
            this.playerBoard = game.creatorBoard;
            this.opponentBoard = game.opponentBoard;
            this.hasShips = true;
          }
       
      } else {
          if(game.opponentShips.length) {
            this.playerBoard = game.opponentBoard;
            this.opponentBoard = game.creatorBoard;
            this.hasShips = true;
          }
            
      }

      if(this.status == "ended") {

          this.$bvModal.show("winner-modal");
      }

      if(this.hasShips && this.status == "created") {
        this.handleReady();
      } else if ( this.status == "created" ){
        this.turn = this.user;
      }

      if(this.status == "playing") {
        game.opponentShips.forEach(ship => {
          if(ship.sink) {
            this.setSunk(ship.ship);
          }
        });
      }

  

    }

  },
  methods : {
    toggleDirection() {
      if(this.direction == "Horizontal") {
        this.direction = "Vertical"
      } else {
        this.direction = "Horizontal"
      }
    },

    canPut(name) {
      return typeof this.ships[name] == undefined ? false : this.ships[name] > 0;
    },

    setShip(name) {
      
      this.selectedShip = name;

      
    },

    putShip: function(x,y) {
      const ship = this.selectedShip;
      const direction = this.direction;

      if(this.canPut(ship)) {
        if(this.validPosition(x, y, direction, SHIP_SIZE[ship]) && !this.checkColision(x, y, direction, SHIP_SIZE[ship])) {

        

          this.drawShip(x,y,direction,SHIP_SIZE[ship]);
          this.ships[ship]--;
          this.shipList.push({ship, x, y, dir: direction, size: SHIP_SIZE[ship]});

        }
      }  

      
    },

    validPosition: function(x,y,direction,size) {
        if(direction == "Horizontal") {
          return x+size <= BOARD_SIZE;
        } else {
          return y+size <= BOARD_SIZE;
        }

    },
    // return true on collision
    checkColision: function(xPos,yPos,direction,size) {
      if(direction == "Horizontal") {
          let delta = xPos + size;
          for(let x = xPos ; x < delta ; x++){
            if(this.playerBoard[yPos][x].me) return true;
          }
      } else {
          let delta = yPos + size;
          for(let y = yPos ; y < delta ; y++){
            if(this.playerBoard[y][xPos].me) return true;
          }
      }
      return false;

    },

    drawShip(xPos ,yPos ,direction, size) {

      if(direction == "Horizontal") {
        for(let x = xPos ; x < xPos + size ; x++){
            this.playerBoard[yPos][x].me = true;
        }
      } else {
        for(let y = yPos ; y < yPos + size ; y++){
            this.playerBoard[y][xPos].me = true;
        }
      }

    },

    reset() {
      Object.keys(this.ships).forEach((key) => {
        this.ships[key] = 1;
      })
      
      this.clearMap();
     
    },

    clearMap() {
      this.playerBoard.forEach((line) => {
        line.forEach((col) => {
          col.me = false;
        })
      })
    },

    handleReady: function () {
      
      this.turn = null;
      this.$socket.emit('ready', this.shipList);

    },

    handleCopy: function () {

      let urlInput = this.$refs.Url;

      urlInput.select();
      urlInput.setSelectionRange(0,999999);

      document.execCommand("copy");
    },

    handleShot: function (x,y) {
      //alert(`Disparou na secção ${x} ${y}`)
      if(this.status == 'playing' && this.turn == this.user && !this.opponentBoard[y][x].hit ) {

        this.canShoot = false;

        this.opponentBoard[y][x].hit = true;

        this.$socket.emit("shot",x,y);

      }
    },

    setSunk: function(ship) {
      if(ship == "carrier") {
        this.carrierSunk = true;
      }

      if(ship == "battleship") {
        this.battleshipSunk = true;
      }

      if(ship == "cruiser") {
        this.cruiserSunk = true;
      }

      if(ship == "submarine") {
        this.submarineSunk = true;
      }

      if(ship == "destroyer") {
        this.destroyerSunk = true;
      }

    },

    intializeBoards : function() {

      for(let y = 0; y < BOARD_SIZE ; y++) {
        for(let x = 0; x < BOARD_SIZE ; x++) {
          this.playerBoard[y][x].hit = false;
          this.playerBoard[y][x].me = false;
          this.opponentBoard[y][x].hit = false;
          this.opponentBoard[y][x].me = false;
        }
      }
      
      this.ships.carrier = 1;
      this.ships.battleship = 1;
      this.ships.cruiser = 1;
      this.ships.submarine = 1;
      this.ships.destroyer = 1;


    }
  

    





  },
  async beforeMount() {
    this.$socket.emit('leaveGames');
    this.intializeBoards();
    this.$socket.emit('join', this.roomId);
    this.user = (await UserService.getUser()).username;
  },
  computed : {
    isReady: function () {
      return Object.values(this.ships).reduce((a, b) => a + b) == 0;
    }
  },
  components: {
    Board,
    Chat
  }
}
</script>
